//
// Created by doggo on 03/03/2021.
//

#ifndef YERBACON_PARSECOMPONENTS_HPP
#define YERBACON_PARSECOMPONENTS_HPP

#include <iostream>
#include <vector>
using namespace std;

class ParseComponent {
public:

};

class ParseTree {
protected:
    vector<ParseComponent> subComponents;
public:
    auto& getComponents() { return subComponents; }
    void add(const ParseComponent component) { subComponents.emplace_back(component); };
    void addAll(const vector<ParseComponent>& components) { for (const auto& comp: components) add(comp); }
    ParseTree(): subComponents() {};
};

#endif //YERBACON_PARSECOMPONENTS_HPP
